#include <stdio.h>
#include <wiringPi.h>
#include <wiringPiSPI.h>

#define MCP3002Channel  0	// MCP3002のISPチャネル

//   MCP3002 制御関数
//   int adc(int ch)
//   ch   : 0ならCH0, 1ならCH 1
//   返り値 : 0x000-0x3ffまでの整数。
//   #define でMCP3002Channelを定義しておくこと
int adc(int ch) {
    unsigned char high;
    unsigned char low = 0;
    unsigned char buf[2];

    if (ch==0)  high = 0x68; else high = 0x78;	// CH0またはCH1の指定
    buf[0] = high;
    buf[1] = low;

    wiringPiSPIDataRW(MCP3002Channel, buf, 2);

    return(((buf[0] & 0x03) << 8) | buf[1]);
}

main() {
    int vol;
    int sens;

    wiringPiSetup();
    wiringPiSPISetupMode(MCP3002Channel, 1000000, 0); // SPI 1Mbps Mode0

    for(;;) {
	vol = adc(0);
	sens = adc(1);
	printf("%04x -> %3.0f %%    %04x -> %3.0f %%\n",
		vol, (float)vol / 1023 * 100,
		sens, (float)sens / 1023 * 100);
	delay(100);
    }
}

